--SJISに依存したコードになってしまっているので、UTF8用も作りたいが、UTF8用だとRubyで作ったほうが楽かも……。

u2s=encoding.utf8_to_ansi -- 短く呼び出せるようにする
s2u=encoding.ansi_to_utf8 -- 短く呼び出せるようにする

function main ()
	console.print("---------------------------------")
	console.print("-- 台本作成ツール")
	console.print("---------------------------------")
	while true do
		console.print("\n■MENU■")
		console.print("0:終了する")
		console.print("1:フォルダ内のテキストファイルを連結・整形・チェックし、タグファイルへと変換")
		console.print("2:出演者リストに指定されたキャラのセリフに連番を振りスクリプトファイルと台本ファイルを作成する。")
		console.print("")
		console.write("> ")
		str=console.readline()
		num=tonumber(str)
		if num==0 then
			os.exit(0)
		elseif num==1 then
			Exec1()
		elseif num==2 then
			Exec2()
		end
	end
end

lk0=u2s("「")
lk1=u2s("『")
lk2=u2s("（")
rk0=u2s("」")
rk1=u2s("』")
rk2=u2s("）")


head0=u2s(";$●")
head1=u2s(";$■")

function Exec1()
	console.print("シナリオファイルが全部格納されたフォルダを選択してください。")
	dir=gui.dirdialog()
	if dir==nil then return end
	console.print("フォルダ\""..s2u(dir).."\"が指定されました。")
	console.print("作品名を入力してください。")
	console.write("> ")
	local sn=console.readline()
	sn=sn:sub(1,-3) -- \r\n削除
	console.print ("作品名\""..sn.."\"が指定されました。")
	console.print("ファイルの保存先を指定してください。")
	local fn=gui.savedialog("txt",u2s(sn.."_tag"))
		if not fn then
		console.print ("エラー：出力ファイル名が指定されませんでした。")
		os.execute("pause")
		return
	end

	local flist=gui.getfilelist(dir,"txt")
	local tbl={}


	for i,v in ipairs(flist) do
		local f=io.open(dir.."\\"..v,"r")
		if f then
			tbl[#tbl+1]=";$filebegin "..v.."\n"
			while true do
				local s=f:read("*l")
				if not s then break end

				--行頭の空白（これは半角のみ）を削る
				while true do
					if s:sub(1,1)==" " or s:sub(1,1)=="\t" then
						s=s:sub(2,-1)
					else
						break
					end
				end

				--末尾の空白（半角も全角も）を削る
				while true do
					if s:sub(-1)==" " or s:sub(-1)=="\t" then
						s=s:sub(1,-2)
					elseif s:sub(-2)==u2s("　") then
						s=s:sub(1,-3)
					else
						break
					end
				end

				--コメント行以外は全角文字に変換する
				if s~="" and s:sub(1,1)~=";" then
					us=s2u(s)
					t=encoding.zenkaku(us)
					s=u2s (t)
				end

				tbl[#tbl+1]=s.."\n"
			end
			if tbl[#tbl]:sub(-1)~="\n" then tbl[#tbl+1]="\n" end
			tbl[#tbl+1]=";$fileend "..v.."\n\n"
		else
			console.print("エラー：ファイル"..s2u(v).."が開けません。")
			os.execute("pause")
			break
		end
		f:close()
	end

	local out=io.open("temp1.txt","w")
	out:write(table.concat(tbl))
	out:close()

	do
		local f=io.open("temp1.txt","r")
		local s=f:read("*a")
		s=s:replace(u2s("【"),"@")
		s=s:replace(u2s("】\n"),"")
		local wf=io.open("temp.txt","w")
		wf:write(s)
		wf:close()
	end

	local log={"ファイル\""..s2u(fn).."\"を作成します。\n"}
	local f=io.open("temp.txt","r")
	local wf=io.open(fn,"w")
	--行の長さ／カッコ対応チェック
	local ln=1
	local namelist={}
	while true do
		local s=f:read("*l")
		if not s then break end
		if s:sub(1,1)~=";" then --コメント行以外を処理
			if #s>200 then log[#log+1]="line "..ln.." : ２００文字を超えています。\n" end
			--カッコの対応チェック
			local n0,n1,n2=0,0,0
			local p=1
			local slen=#s
			while true do
				local c=s:sub(p,p+1)
				if (c==lk0) then n0=n0+1 end
				if (c==lk1) then n1=n1+1 end
				if (c==lk2) then n2=n2+1 end

				if (c==rk0) then n0=n0-1 end
				if (c==rk1) then n1=n1-1 end
				if (c==rk2) then n2=n2-1 end
				p=p+1
				if p>slen then break end
			end
			if n0~=0 or n1~=0 or n2~=0 then
				log[#log+1]="line "..ln.." : 開きカッコと閉じカッコの数が合いません。\n"
			end
			if s:sub(-2)==rk0 or s:sub(-2)==rk1 or s:sub(-2)==rk2 or s:sub(1,1)=="@" then
				--セリフ行とみなし、タグに変換
				local p=1
				local bs
				if s:sub(1,1)=="@" then
					bs=s:sub(2)
				else
					bs=s
				end


				s="["
				while true do
					local c=bs:sub(p,p+1)
					if (c==lk0 or c==lk1 or c==lk2) then break end
					p=p+1
					if p>slen then break end
				end
				if p>slen then
					--ここにはこないはず……なぜ？
					s=bs
				else
					local name=bs:sub(1,p-1)
					s=s..name.."]"..bs:sub(p,-1)
					if namelist[name] then
						namelist[name]=namelist[name]+1
					else
						namelist[name]=1
					end
				end
			end
		end
		wf:write(s.."\n")
		ln=ln+1
	end
	log[#log+1]="タグファイル作成処理を終了しました。\n\n出演者とセリフ数:\n"
	for k,v in pairs(namelist) do
	log[#log+1]=s2u(k).." : "..v.."個\n"
	end
	log[#log+1]="\n問題がある場合出力ファイルを書き換えて対応してください。\n"
	f:close()
	wf:close()
	os.remove("temp1.txt")
	os.remove("temp.txt")
	local logname=u2s(sn.."_変換ログ.txt")
	out=io.open(logname,"w")
	out:write(table.concat(log))
	out:close()
	gui.shell (s2u(logname)) -- utf-8ベタテキストを渡す仕様になってるため
end

function Exec2()
	console.print ("入力するタグファイルを選択してください。")
	local fn=gui.loaddialog("txt")
	if not fn then
		console.print("ファイルを開けませんでした。")
		return
	end
	local sn=fn:match("(.*)_tag.txt") or fn:match("(.*).txt") or fn
	console.print(sn)
	console.print ("出演者リストファイルを選択してください。")
	local afn=gui.loaddialog("txt")
	if not afn then
		console.print("ファイルを開けませんでした。")
		return
	end
	console.print ("出力スクリプトファイル名を指定してください。")
	local scrn=gui.savedialog("txt",sn..u2s("_スクリプト"))
	if not scrn then
		console.print("ファイルを開けませんでした。")
		return
	end

	local actor={}

	local af=io.open(afn,"r")
	while true do
		local s=af:read("*l")
		if not s then break end
		local ret=string.splita(s,",")
		if #ret>1 then
			local tbl={}
			for i=2,#ret do
					tbl[#tbl+1]=ret[i]
			end
			actor[#actor+1]={tbl,ret[1]}
		end
	end

	af:close()

	local f=io.open(fn,"r")
	local out={}
	while true do
		local s=f:read("*l")
		if not s then break end
		out[#out+1]=s
	end

	for i,v in ipairs(actor) do
		for i2=1,#out do
			if out[i2]:sub(1,1)=="[" then
				local name=out[i2]:match("%[(.-)%]")
				for i3,v3 in ipairs(v[1]) do
					if v3==name then
						local temp=out[i2]:match("%].*$")
						out[i2]="["..name.."/"..string.format("%05d",v[2])..temp
						v[2]=v[2]+1
						break
					end
				end
			end
		end
	end
	f:close()
	local wf=io.open(scrn,"w")
	for i,v in ipairs(out) do
		wf:write(v.."\n")
	end
	wf:close()

	--台本ファイルを作ります。
	for i,v in ipairs(actor) do
		--普通の台本ファイル
		local fn=sn..u2s("台本_")..v[1][1]..".txt"
		--台詞のみのファイル
		local fn2=sn..u2s("台本_")..v[1][1]..u2s("(台詞のみ).txt")
		local f=io.open(fn,"w")
		local f2=io.open(fn2,"w")
		for i2,v2 in ipairs(out) do
			if v2:sub(1,1)=="[" then
				local name,text=v2:match("%[(.-)%](.*)$")
				local flag=false
				local no
				if name:match("/") then
					name,no=string.split(name,"/")
				end
				for i3,v3 in ipairs(v[1]) do
					if v3==name and no then
						flag=true
						local str=no..":"..name..text.."\n"
						f:write(head1..str)
						f2:write(str)
					end
				end
				if not flag then
					f:write(head0..name..text.."\n")
				end
			else
				if v2:sub(1,2)==";$" or v2:sub(1,1)=="" then
					f:write(v2.."\n")
				else
					f:write(head0..v2.."\n")
				end
			end
		end
		f:close()
		f2:close()
	end

	--登場しないシーンを削った台本ファイルを作ります。
	for i,v in ipairs(actor) do
		--元の台本ファイル
		local dellist={} -- 削除する行範囲を表す配列
		local fn=sn..u2s("台本_")..v[1][1]..".txt"
		local fn2=sn..u2s("台本_")..v[1][1].."_trim.txt"
		local f=io.open(fn,"r")
		local ln=1
		local nowstartline=nil
		local flag=false
		while true do
			local s=f:read("*l")
			if not s then break end
			if s:sub(1,11)==";$filebegin" then
				if nowstartline~=nil then
					console.print ("エラー：line "..ln.." ;$filebeginと;$fileendが正しく対応していません。\n")
					return
				end
				nowstartline=ln
				flag=false
			elseif s:sub(1,9)==";$fileend" then
				if not nowstartline then
					console.print ("エラー：line "..ln.." ;$filebeginと;$fileendが正しく対応していません。\n")
				end
				if not flag then
					local index=#dellist+1
					dellist[index]={}
					dellist[index].b=nowstartline
					dellist[index].e=ln
				end
				nowstartline=nil
			else
				if s:sub(1,4)==head1 then flag=true end
			end
			ln=ln+1
		end
		f:close()
		
		--出力ファイル

		if dellist[1]==nil then
			console.print ("台本トリミングの必要はありませんでした。出力しません。")
			return
		end
		local f2=io.open(fn2,"w")
		ln=1
		f=io.open(fn,"r")
		local delmode=false
		local index=1
		while true do
			local s=f:read("*l")
			if not s then break end
			if delmode then
				if dellist[index].e==ln then
					delmode=false
					index=index+1
					if index>#dellist then
						f2:write(f:read("*all"))
						break
					end
				end
			else
				if dellist[index].b==ln then
					delmode=true
				else
					f2:write(s.."\n")
				end
			end
			ln=ln+1
		end
		f:close()
		f2:close()
	end

end


main()
